
extern "C" {
  #include "user_interface.h"
  #include "config.h"
}

#ifdef USE_FUNCKIT
static int _isUtf( char* p )
{
    int     ret = 0;

    if ( *p != '&' )
        return 0;

    p++;
    if ( *p != '#' )
        return 0;
    p++;

    for ( ret=3; *p && *p >= '0' && *p <= '9'; p++, ret++ );

    if (*p == ';' )
        return ret;

    return 0;

}

static uint32_t _HexString( char *p)
{
  uint32_t val=0;
  uint32_t z;

  if ( *(p+1) == 'x' )
    p+=2;
  else if ( *p == 'x' )
    p++;
  for( ; *p; p++ )
  {
    if ( *p > '9' )   /* ascii */
    {
      *p |= 32;       /* lower case */
      z= *p - 'a' + 10;
    }
    else
      z= *p - '0';
    val <<= 4;
    val |= z;
  }
  return val;
}

#define MAXAV  15

/* zerlegen des Strings s_in in einen argv-vektor */
/* argv - return, argc - return, scont - sonder-control */
char **	VfkCutStrg( char * s_in, int * argc, char scont )
{
static char *av[MAXAV+1];
	int		ac = 0;
	int		i;
	char	*p;
	char	*a;
	char	**erg = 0;
	char	x;
	char	ee = 0;
	char	deli = 0;

	p = s_in;
	while( 1 )
	{
		x = *p;
		/* if (( x == 0 ) || ( x == '\n' )) ende string */
		if ( x == 0 ) /* ende string */
		{
			if ( scont )
			{
				av[ac] = p;
				ac++;
			}
			ee = 1;
			break;
		}
		if ( !scont )
		{
			if (( x == ' ' ) || ( x == '\t' ))  /* ueberlesen */
			{
				p++;
				continue;
			}
		}
		deli = 0;
		if (( x == '"' ) || ( x == '\'' ))
		{
			deli = x;
			p++;
		}
		a = p;
		x = 0;
		while( 1 )
		{
			int n = 0;
			x = *p;
			if ( x == '\\' )
			{
				p++;
				p++;
				continue;
			}
			if ( ( n = _isUtf( p ) ) > 0 )
			{
				p += n;
				continue;
			}

			/* if (( x == 0 ) || ( x == '\n' ))	ende string */
			if ( x == 0 )	/* ende string */
			{
				ee = 1;
				break;
			}
			if ( !deli && ( x == scont ) )
				break;
			if ( deli )
			{
				if ( x == deli )
				{
					*p = 0;
					if ( *(p+1) != 0 )
					{
						p++;
						if (( *p == '\r' ) || ( *p == '\n' ))
							ee=1;
					}
					else
						ee=1;
					break;
				}
			}
			else
			{
				if ( !scont )
				{
					if (( x == ' ' ) || ( x == '\t' ))
						break;
				}
			}
			p++;
		}
		*p = 0;
		av[ac] = a;
		ac++;
		if ( ac == MAXAV )
			break;
		if ( ee )
			break;
		p++;
	}
	*argc = ac;
	if ( ac )
	{
		erg = (char**)malloc(sizeof(char*)*(ac+1));
		for( i=0; i < ac; i++ )
			erg[i] = av[i];
		erg[i] = 0;
	}
	return( erg );
}

#endif
